/*
 * Copyright (c) 2021. Julien Fischer
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *         http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

/*************************************************************************
    GLOBAL STYLES
*************************************************************************/

html, body {
    font-family: monospace, monospace;
    font-size: .95em;
    background: #eee;
    color: #444;
}

/*************************************************************************
    GLOBAL
*************************************************************************/

table {
    border-collapse: collapse;
    background: white;
    width: 100%;
    color: black;
}

th, td, .table-title {
    border: 1px solid #eee;
    padding: 10px 20px;
}

td {
    padding: 15px 20px;
}

th {
    text-align: left;
}

.table-title {
    cursor: pointer;
}

tr:not(.header) {
    cursor: pointer;
}

tr:hover:not(.header) {
    background: #f3f3f3;
}

/* Push Button */

button.primary {
    background: transparent;
    padding: 6px 12px;
    border: 1px solid #aaa;
    cursor: pointer;
    transition: .2s;
}

button.primary:hover {
    border: 1px solid black;
}

button.secondary,
.close-btn {
    background: transparent;
    border: none;
    color: #ddd !important;
    padding: 12px 12px 12px 30px;
    cursor: pointer;
    font-size: 1.2em;
}

button.secondary:hover,
.close-btn:hover {
    color: white !important;
}

/* Dockable */

.dockable.top {
    top: 0;
    left: 0;
    right: 0;
    height: 40%;
}

.dockable.left {
    left: 0;
    top: 0;
    bottom: 0;
    width: 40%;
}

.dockable.bottom {
    bottom: 0;
    left: 0;
    right: 0;
    height: 40%;
}

.dockable.right {
    right: 0;
    top: 0;
    bottom: 0;
    width: 40%;
}

#dock-area {
    background: rgba(51, 51, 51, .6);
    position: fixed;
}

/*************************************************************************
    Specific
*************************************************************************/

.loading-screen {
    position: fixed;
    top:    0;
    left:   0;
    bottom: 0;
    right:  0;
    background: rgba(0, 0, 0, 1);
}

.spinner {
    position: absolute;
    top: 50%;
    left: 50%;
}

.progress {
    width: 100%;
    height: 20px;
    color: #f4fafc;
    position: absolute;
    top: 50%;
    left: 0;
    margin-top: -20px;
    text-align: center;
    font-size: 1.5em;
}

#dashboard {
    display: flex;
    flex-direction: column;
    width: 100%;
    height: 100vh;
}

#metrics {
    margin: 10px 10px 10px 10px;
    padding-left: 15px;
    font-weight: bold;
    display: flex;
    border-left-width: 4px;
    border-left-style: solid;
}


.metrics-entries {
    flex-grow: 1;
}

#metrics.error {
    /*border-left-color: #f07171;*/
    border-left-color: red;
}

#metrics.success {
    border-left-color: green;
}

.metrics-pie-container {
    margin-top: 10px;
    display: flex;
}

.metrics-pie {
    margin-right: 10px;
}

.legend-container {
    margin-top: 5px;
    margin-right: 20px;
}

.legend-entry {
    margin-bottom: 5px;
}

.legend-entry div {
    display: inline-block;
    vertical-align: middle;
}

.legend-entry-color {
    width: 20px;
    height: 20px;
    border-radius: 2px;
}

.legend-entry-name {
    margin-left: 10px;
    color: #555;
}

.metrics-entry { }

.metrics-value.success {
    color: green;
}

.metrics-value.error {
    color: red;
    /*color: #e75e5e;*/
}

.metrics-value.warn {
    color: #e69500;
}

#dashboard-controls {
    display: flex;
    margin: 10px 25px 5px 10px;
    padding-bottom: 10px;
}

.summary {
    box-shadow: 0 0 5px rgba(0, 0, 0, .3);
    border-bottom: 3px solid rgba(0, 0, 0, .2);
}

.filter-buttons {
}

.filter-input {
    flex-grow: 1;
    margin: 0 20px;
    padding: 0 10px;
    border-radius: 4px;
    border: 1px solid gray;
}

.filter-input:focus {
    border: 1px solid black;
    outline: 1px solid black;
}

.accordion {
    overflow: auto;
    flex-grow: 1;
    padding: 10px 10px 15px 10px;
}

.result-table {
    box-shadow: 3px 3px 5px rgba(0, 0, 0, .2);
    margin-bottom: 10px;
    text-align: left;
    overflow-x: auto;
}

.header, .table-title {
    text-transform: capitalize;
}

.table-title {
    background: white;
    font-weight: bold;
    border-bottom: 1px solid #eee;
    display: flex;
}

.table-detail {
    flex-grow: 1;
}

.table-toggle-button {

}

.table-toggle-button span {
    vertical-align: top;
}

.table-toggle-label {
    margin-right: 10px;
}

.table-toggle-arrow {
    font-size: 20px;
}

.package-name {
}

.package-io {
    background: black;
}

.package-decoders {
    background: var(--palette-green);
}

.package-highlighters {
    background: teal;
}

.package-encoders {
    background: tomato;
}

.package-utils {
    background: var(--palette-blue);
}

.package-internal {
    background: var(--palette-red);
}
.package-components {
    background: var(--palette-teal);
}

.package-controls {
    background: var(--palette-yellow);
}

.package-models {
    background: #555;
}

/* Code Viewer */

.code-viewer {
    position: fixed;
    background: #333;
    text-align: left;
    color: #ddd;
    font-size: 1.2em;
    transition: .1s ease-out;
    box-shadow: 0 -2px 5px rgba(0, 0, 0, .5);
    line-height: 1.5;
    display: flex;
    flex-direction: column;
}

.code-viewer.top.closed {
    top: -100%;
}
.code-viewer.left.closed {
    left: -100%;
}
.code-viewer.bottom.closed {
    bottom: -100%;
}
.code-viewer.right.closed {
    right: -100%;
}

.code-viewer.left .code-viewer-title,
.code-viewer.right .code-viewer-title {
    overflow-x: auto;
}

.code-viewer.left .close-btn,
.code-viewer.right .close-btn {
    margin-bottom: 15px;
}

.code-viewer-topbar {
    display: flex;
    background: #3c3c3c;
    margin-bottom: 10px;
    white-space: nowrap;
}

.code-viewer-title {
    padding: 10px;
}

.code-viewer-title div {
    display: inline-block;
    vertical-align: top;
}

.code-viewer-status-container {
    flex-grow: 1;
    padding-top: 10px;
    margin-left: 20px;
}

.code-viewer-status {
    border-radius: 5px;
    padding: 2px 8px;
    font-size: .8em;
    display: inline-block;
}

.code-viewer-status.success {
    background: #3e593e;
}

.code-viewer-status.error {
    background: #6f4343;
}

.snippet {
    overflow: auto;
    /*max-height: 350px;*/
    margin: 0 10px 0 10px;
    flex-grow: 1;
}

/*************************************************************************
    Syntax Highlighting
*************************************************************************/

.code.lib {
    color: #c096d6;
}

.code.keyword {
    color: orange;
}

.code.comment {
    color: #999;
}

.code.string {
    color: #94cd8c;
}

.code.regex {
    color: #ff7373;
}

